-- if a rogue
_, eclass = UnitClass("PLAYER");
if (eclass == "ROGUE") then
	-- settings
	local audio = true;	-- bool - do you want a sound reminder?
	local visual = true;	-- bool - do you want a visual reminder?
	local enabled = true;	-- bool - is the addon enabled?
	local vf_width = 400;	-- int  - what should the width be?
	local vf_height = 200;	-- int  - what should the height be?
	-- "You are not prepared!" by default - "Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav"
	local audioClip = "Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav";
	local icd = 5;		--5 seconds.
	local TextAlert = "Use Dispatch!";
	local xOffset = 0;
	local yOffset = 0;
	-- end settings
	
	local mir_icd = GetTime();
	local mutName = GetSpellInfo(1329);
	local dispName = GetSpellInfo(111240);
	local blindName = GetSpellInfo(121153);
	local SFName = GetSpellInfo(112942);
	
	mir_visualFrame = CreateFrame("MessageFrame", "mir_visualFrame", UIParent)
	mir_visualFrame:SetPoint("BOTTOM", UIParent, "CENTER", xOffset, yOffset);
	mir_visualFrame:SetWidth(600);
	mir_visualFrame:SetHeight(400);
	mir_visualFrame:SetTimeVisible(4);
	mir_visualFrame:SetFadeDuration(1);
	mir_visualFrame:SetFont("Fonts\\FRIZQT__.TTF", 200);
	mir_visualFrame:Show();
	
	-- reminder method
	function mir_reminder()
		curTime = GetTime();
		if audio then
			if( mir_icd+icd < curTime ) then
				mir_icd = GetTime();
				-- Plays a sound clip
				PlaySoundFile(audioClip);
			end
		end
		if visual then
			-- shows the visual reminder
			mir_visualFrame:Clear();
			mir_visualFrame:AddMessage(TextAlert);
		end
	end

	-- conditionals
	function mir_run(char, castName, targ)
		-- if MIR is enabled and spec'd for MI
		if enabled and specdMI then
			pName, pRealm = UnitName("PLAYER");
			if castName == mutName and char == "player" then
				-- if target is below 35%
				local n = UnitAura("PLAYER", blindName)
				if (UnitHealth("TARGET") < (UnitHealthMax("TARGET") * .35) and UnitPower("PLAYER") < 100) or n == blindName then
					mir_reminder();
				end
			end
		end
	end

	function mir_specCheck()
		if GetSpecialization() == 1 and UnitLevel("PLAYER") >= 40 then
			specdMI = true;
		else
			specdMI = false;
		end
	end

	-- register event
	local mirFrame = CreateFrame("Frame", "mirFrame", UIParent);
	mirFrame:RegisterEvent("UNIT_SPELLCAST_SENT");
	mirFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	mirFrame:RegisterEvent("PLAYER_TALENT_UPDATE");
	mirFrame:RegisterEvent("CHARACTER_POINTS_CHANGED");
	local function eventHandler(self, event, ...)
		if event == "UNIT_SPELLCAST_SENT" then
			caster, spellName, _, target = ...;
			mir_run(caster, spellName, target);
		end

		if event == "ACTIVE_TALENT_GROUP_CHANGED" or event == "PLAYER_TALENT_UPDATE" or event == "CHARACTER_POINTS_CHANGED" then
			mir_specCheck()
		end
	end
	mirFrame:SetScript("OnEvent", eventHandler);


	-- slash handler
	function SlashCmdList.MIR(msg, editBox)
		msg, setting = string.split(' ', msg);
		if string.lower(msg) == "enabled" or string.lower(msg) == "enable" or msg == "1" then
			if not enabled then
				print("Enabling MIR.");
			else
				print("Already enabled.");
			end
			enabled = true;
		elseif string.lower(msg) == "disable" or string.lower(msg) == "disabled" or msg == "0" then
			if enabled then
				print("Disabling MIR.");
			else
				print("Already disabled.");
			end
			enabled = false;
		elseif string.lower(msg) == "isenabled" then
			if enabled then
				print("MIR: enabled.");
			else
				print("MIR: disabled.");
			end
		elseif string.lower(msg) == "setvisual" then
			if setting == "1" or setting == "true" or setting == "t" then
				if not visual then
					print("Enabling the visual warning.");
				else
					print("The visual warning is already enabled.");
				end
				visual = true;
			elseif setting == "0" or setting == "false" or setting == "f" then
				if visual then
					print("Disabling the visual warning.");
				else
					print("The visual warning is already disabled.");
				end
				visual = false;
			else
				print("Unknown setting: "..setting);
			end
		elseif string.lower(msg) == "setaudio" then
			if setting == "1" or setting == "true" or setting == "t" then
				if not audio then
					print("Enabling the audio warning.");
				else
					print("The audio warning is already enabled.");
				end
				audio = true;
			elseif setting == "0" or setting == "false" or setting == "f" then
				if audio then
					print("Disabling the audio warning.");
				else
					print("The audio warning is already disabled.");
				end
				audio = false;
			else
				print("Unknown setting: "..setting);
			end
		else
			print("MIR");
			print("/mir enabled  -- enables the addon");
			print("/mir disabled  -- disables the addon");
			print("/mir isEnabled  -- returns whether or not the addon is enabled");
			print("/mir setVisual [0/1] -- sets whether or not the visual portion is enabled");
			print("/mir setAudio [0/1] -- sets whether or not the audio portion is enabled");
		end
	end

	-- register slash command
	SLASH_MIR1 = "/mir"
end
-- end